
local timeStart = -1;

LootFast2={};

function LootFast2.Load(self)
	self:RegisterEvent("LOOT_OPENED");
	self:RegisterEvent("START_LOOT_ROLL");
	self:RegisterEvent("ITEM_PUSH");
	self:RegisterEvent('ADDON_LOADED');
	self:RegisterEvent('PLAYER_ENTERING_WORLD');
end
function LootFast2.Update()
	if(timeStart >= 0) then
		if(GetTime() - timeStart >= LF2Settings.closeLoot) then
			CloseLoot();
			timeStart = -1;
		end
	end
end
function LootFast2.List(var)
	if(var == "Tog" or var == "tog") then
		--Toggle Enable
		LootFast2.Config.Toggle();
	end
	if(strsub(var, 1, 6) == "Close:" or strsub(var, 1, 6) == "close:") then
		--Auto Close, -1 Off, 0 Don't Open, Close after X seconds.
		LootFast2.Config.SetCloseOption(tonumber(strsub(var, 7)));
	end
	if(strsub(var, 1, 9) == "LootState" or strsub(var, 1, 9) == "lootstate" or strsub(var, 1, 9) == "lootState" or strsub(var, 1, 9) == "Lootstate") then
		if(strsub(var, 10) == "") then
			LootFast2.Config.SetLootState(LF2Settings.AllBut + 1);
		else
			LootFast2.Config.SetLootState(tonumber(strsub(var, 11)));
		end
	end
	if(var == "Reset" or var == "reset") then
		LootFast2.Config.Reset();
	end
	if(strsub(var, 1, 5) == "Name " or strsub(var, 1, 5) == "name ") then
		--Filter by Name
		local nam, num = strsplit(":", strsub(var, 6));
		LootFast2.Config.SetNameFilter(nam,num);
	end
	if(strsub(var, 1, 8) == "Quality " or strsub(var, 1, 8) == "quality ") then
		--Filter by Quality
		local qual, num = strsplit(":", strsub(var, 9));
		qual = tonumber(qual);
		num = tonumber(num);
		LootFast2.Config.SetQuality(qual,num);
	end
	if(var == "List" or var == "list") then
		if(LF2Settings.Enabled == 1) then
			DEFAULT_CHAT_FRAME:AddMessage("LootFast is on");
		else
			DEFAULT_CHAT_FRAME:AddMessage("LootFast is off");
		end
		if(LF2Settings.closeLoot >= 0) then
			DEFAULT_CHAT_FRAME:AddMessage("LootFast will close the loot window after " .. LF2Settings.closeLoot .. " Seconds.");
		else
			DEFAULT_CHAT_FRAME:AddMessage("LootFast will not close the loot window.");
		end
		DEFAULT_CHAT_FRAME:AddMessage("Names specified:");
		for k in pairs(LF2Settings.LootName) do
			if(LF2Settings.LootName[k] >= 1) then
				DEFAULT_CHAT_FRAME:AddMessage(k .. ": " .. LF2Settings.LootName[k]);
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("Qualities specified:");
		for k in pairs(LF2Settings.LootQual) do
			if(LF2Settings.LootQual[k] >= -1) then
				qual = k;
				if(qual == -1) then
					nam = "|cFF00ccffMoney|r";
				elseif(qual == 0) then
					nam = "|cff9d9d9dPoors|r";
				elseif(qual == 1) then
					nam = "|cffffffffCommons|r";
				elseif(qual == 2) then
					nam = "|cff1eff00Uncommons|r";
				elseif(qual == 3) then
					nam = "|cff0070ddRares|r";
				elseif(qual == 4) then
					nam = "|cffa335eeEpics|r";
				elseif(qual == 5) then
					nam = "|cffff8000Legendaries|r";
				end
				DEFAULT_CHAT_FRAME:AddMessage(nam .. ": " .. LF2Settings.LootQual[k]);
			end
		end
	end
	if(var == "Config" or var == "config") then
		LootFast2.Config.Open();
	end
	if(var == "") then
		DEFAULT_CHAT_FRAME:AddMessage("LootFast2 Commands:");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF : lists commands");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Tog : toggles on/off");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Close:# : sets close time: -1 means don't close, 0 means close immediately (never opens) and greater than 0 is the number of seconds to leave the loot window open");
		DEFAULT_CHAT_FRAME:AddMessage("For the following commands, the # sets the greediness of the looting. 0: do not auto loot, 1: auto loot, 2: auto greed on rolls, 3: auto accept BoP items");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF LootState:# : sets the loot state (0 is default). if no number is given, will cycle through possible states");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Name itemname:# : adds the item to the loot filter (full item name required. do not include brackets)");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Quality #:# : sets the quality level represented by the first # to the loot level given by the second (-1:money 0:grey, 1:white, 2:green, 3:blue, 4:purple, 5:orange)");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Reset : clears all stored data.");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF List : lists current loot filters.");
		DEFAULT_CHAT_FRAME:AddMessage("  /LF Config : Show Config GUI.");
	end
end
function LootFast2.InitSettings()
	LF2Settings={
		MinimapPos = 45,
		MinimapEnabled = 1,
		Enabled = 1,
		closeLoot = 0,
		LootName = {},
		AllBut = 0,
		LootQual = {1, 1, 1, 1, 1},
		LootNameKeys = {}
	};
	LF2Settings.LootQual[0] = 1;
	LF2Settings.LootQual[-1] = 1;
end
function LootFast2.OnEvent(event,...)
	if(event == "ADDON_LOADED") then
		local arg1 = ...;
		if(arg1 == "LootFast2") then
			SlashCmdList["LOOTFASTCMDLIST"] = LootFast2.List;
			SLASH_LOOTFASTCMDLIST1 = "/LootFast";
			SLASH_LOOTFASTCMDLIST2 = "/LF";
			SLASH_LOOTFASTCMDLIST3 = "/lf";
			SLASH_LOOTFASTCMDLIST4 = "/Lf";
			SLASH_LOOTFASTCMDLIST5 = "/lootfast";
			SLASH_LOOTFASTCMDLIST6 = "/Lootfast";
			SLASH_LOOTFASTCMDLIST7 = "/lootFast";
			
			if(not LF2Settings) then
				--DEFAULT_CHAT_FRAME:AddMessage("LootFast: InitSettings!"); --DEBUG
				--DEFAULT_CHAT_FRAME:AddMessage("LootFast: "..tostring(LF2Settings)); --DEBUG
				LootFast2.InitSettings();
			end
			
			if(LF2Settings.LootQual[-1] == nil) then
				LF2Settings.LootQual[-1] = 1;
			end
			
			LootFast2.Config.InitConfigDropDowns();
		end
	end
	if(event == "PLAYER_ENTERING_WORLD") then
		--Setup UI Here.
		if LF2Settings.MinimapEnabled == 1 then
			LootFast2.Minimap.Reposition();
		end
	end
	if ( event == "LOOT_OPENED" ) then
		if( LF2Settings.Enabled == 1) then
			local i = 1;
			local icon, name, quan, rare = GetLootSlotInfo(i);
			while(icon ~= nil) do 
				--ChatFrame1:AddMessage(name .. ", " .. quan .. ", " .. rare .. ", " .. LF2Settings.LootQual[rare]);
				--ChatFrame1:AddMessage(strsub(icon, 1, 29) .. " == " .. "Interface\\Icons\\INV_Misc_Coin");
				if(strsub(icon, 1, 29) == "Interface\\Icons\\INV_Misc_Coin") then
					if(LF2Settings.LootQual[-1] == nil) then
						LF2Settings.LootQual[-1] = 1;
					end
					if(LF2Settings.LootQual[-1] > 0) then
						LootSlot(i);
					end
				else
					if(LF2Settings.LootQual[rare] >= 1 or ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 1) and LF2Settings.AllBut == 0) or (not ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 1)) and LF2Settings.AllBut >= 1)) then
						LootSlot(i);
						if(LF2Settings.LootQual[rare] >= 3 or ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 3) and LF2Settings.AllBut == 0) or (not ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 1)) and LF2Settings.AllBut >= 3)) then
							ConfirmLootSlot(i);
						end
					end
					
					
				end
				
				i = i + 1;
				icon, name, quan, rare = GetLootSlotInfo(i);
			end
			if(LF2Settings.closeLoot <= 0) then
				if(LF2Settings.closeLoot == 0) then
					CloseLoot();
				end
				timeStart = -1;
			else
				timeStart = GetTime();
			end
		end
	end
	if (event == "START_LOOT_ROLL") then
		if( LF2Settings.Enabled == 1) then
			local id = ...;
			local icon, name, quan, rare = GetLootRollItemInfo(id);
			--ChatFrame1:AddMessage(name .. ", " .. quan .. ", " .. rare .. ", " .. LF2Settings.LootQual[rare]);
			if(LF2Settings.LootQual[rare] >= 2 or ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 2) and LF2Settings.AllBut == 0) or (not ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 1)) and LF2Settings.AllBut >= 2)) then
					RollOnLoot(id, 2);
					if(LF2Settings.LootQual[rare] >= 3 or ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 3) and LF2Settings.AllBut == 0) or (not ((LF2Settings.LootName[name] ~= nil and LF2Settings.LootName[name] >= 1)) and LF2Settings.AllBut >= 3)) then
						ConfirmLootRoll(id, 2);
					end
			end
		end
	end
	if (event == "ITEM_PUSH") then
		if( LF2Settings.Enabled == 1) then
			bag = ...;
			local i = 1;
			--local icon, name, quan, rare = GetLootSlotInfo(i);
			--DeleteCursorItem();
		end
	end
end
function LootFast2.ButtonTips(button)
	if(button == "LootFast2_MinimapButton")then
		GameTooltip:SetOwner(LootFast2_MinimapButton);
		GameTooltip:SetText("LootFast2", nil, nil, nil, nil, 1);
		GameTooltip:AddLine("|cFFFFFFFFLeft Click:|r Toggle LootFast");
		GameTooltip:AddLine("|cFFFFFFFFRight Click:|r Open Options");
	end
	GameTooltip:Show();
end
